uniform float a;
uniform float b;

float julia(void)
{
  const float density = 32.0;
  
  float x = (gl_TexCoord[0].x - 0.5) * 2.0;
  float y = (gl_TexCoord[0].y - 0.5) * 2.0;
  float x2;
  float y2;
  float xy;
  float r = 1.0;
  float k = density;
  
  while((k > 0.0) && (r < 4.0))
  {
    x2 = x * x;
    y2 = y * y;
    xy = x * y;
    x = x2 - y2 + a;
    y = 2.0 * xy + b;
    r = x2 + y2;
    k--;
  }
  return k / density;
}
void main(void)
{
  float j = 1.0 - julia();
  gl_FragColor = vec4(j, j * j, j * j * j, 1.0) * gl_Color;
}